#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 2 "grammar.y"
/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
#ifndef lint
static const char rcsid[] =
    "@(#) $Header: /cvs/fragrouter/libpcap-0.4/grammar.y,v 1.1.1.1 1999/05/03 04:06:43 dugsong Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>

#if __STDC__
struct mbuf;
struct rtentry;
#endif

#include <net/if.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>

#include <stdio.h>

#include "pcap-int.h"

#include "gencode.h"
#include <pcap-namedb.h>

#include "gnuc.h"
#ifdef HAVE_OS_PROTO_H
#include "os-proto.h"
#endif

#define QSET(q, p, d, a) (q).proto = (p),\
			 (q).dir = (d),\
			 (q).addr = (a)

int n_errors = 0;

static struct qual qerr = { Q_UNDEF, Q_UNDEF, Q_UNDEF, Q_UNDEF };

static void
yyerror(char *msg)
{
	++n_errors;
	bpf_error("%s", msg);
	/* NOTREACHED */
}

#ifndef YYBISON
int yyparse(void);

int
pcap_parse()
{
	return (yyparse());
}
#endif

#line 82 "grammar.y"
typedef union {
	int i;
	bpf_u_int32 h;
	u_char *e;
	char *s;
	struct stmt *stmt;
	struct arth *a;
	struct {
		struct qual q;
		struct block *b;
	} blk;
	struct block *rblk;
} YYSTYPE;
#line 110 "y.tab.c"
#define YYERRCODE 256
#define DST 257
#define SRC 258
#define HOST 259
#define GATEWAY 260
#define NET 261
#define MASK 262
#define PORT 263
#define LESS 264
#define GREATER 265
#define PROTO 266
#define BYTE 267
#define ARP 268
#define RARP 269
#define IP 270
#define TCP 271
#define UDP 272
#define ICMP 273
#define IGMP 274
#define IGRP 275
#define ATALK 276
#define DECNET 277
#define LAT 278
#define SCA 279
#define MOPRC 280
#define MOPDL 281
#define TK_BROADCAST 282
#define TK_MULTICAST 283
#define NUM 284
#define INBOUND 285
#define OUTBOUND 286
#define LINK 287
#define GEQ 288
#define LEQ 289
#define NEQ 290
#define ID 291
#define EID 292
#define HID 293
#define LSH 294
#define RSH 295
#define LEN 296
#define OR 297
#define AND 298
#define UMINUS 299
const short yylhs[] = {                                        -1,
    0,    0,   24,    1,    1,    1,    1,    1,   20,   21,
    2,    2,    2,    3,    3,    3,    3,    3,    3,   23,
   22,    4,    4,    4,    7,    7,    5,    5,    8,    8,
    8,    8,    8,    6,    6,    6,    6,    6,    6,    9,
    9,   10,   10,   10,   10,   10,   10,   11,   11,   11,
   12,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   25,   25,   25,   25,
   25,   25,   25,   18,   18,   18,   19,   19,   19,   13,
   13,   14,   14,   14,   14,   14,   14,   14,   14,   14,
   14,   14,   14,   14,   15,   15,   15,   15,   15,   17,
   17,
};
const short yylen[] = {                                         2,
    2,    1,    0,    1,    3,    3,    3,    3,    1,    1,
    1,    1,    3,    1,    3,    3,    1,    1,    2,    1,
    1,    1,    3,    3,    1,    1,    1,    2,    3,    2,
    2,    2,    2,    2,    3,    1,    3,    3,    1,    1,
    0,    1,    1,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    2,    2,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    4,    6,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    3,    1,    1,    1,    1,    1,    1,    1,
    3,
};
const short yydefred[] = {                                      3,
    0,    0,    0,    0,    0,   54,   55,   53,   56,   57,
   58,   59,   60,   61,   62,   63,   64,   66,   65,  100,
   72,   73,   52,   94,   20,    0,   21,    0,    4,   27,
    0,    0,    0,   81,    0,   80,    0,    0,   39,   69,
   70,    0,   92,    0,    0,   10,    9,    0,    0,   14,
   18,    0,   34,   11,   12,    0,    0,    0,    0,   48,
   51,   49,   50,   32,   67,   68,    0,   31,   33,   75,
   77,   79,    0,    0,    0,    0,    0,    0,    0,    0,
   74,   76,   78,    0,    0,    0,    0,    0,    0,   28,
   96,   95,   98,   99,   97,    0,    0,    6,    5,    0,
    0,    0,    8,    7,    0,    0,   22,    0,    0,    0,
    0,   19,    0,    0,    0,    0,   29,    0,    0,    0,
    0,    0,    0,   86,   87,    0,    0,    0,   35,   93,
  101,   71,    0,   16,   15,   13,    0,    0,    0,   45,
   47,   44,   46,   82,    0,   23,   24,    0,   83,
};
const short yydgoto[] = {                                       1,
   87,  112,   54,  108,   29,   30,  109,   31,   32,   67,
   68,   69,   33,   34,   96,   44,   36,   84,   85,   48,
   49,   45,   57,    2,   39,
};
const short yysindex[] = {                                      0,
    0,  -29, -261, -249, -243,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  288,    0, -290,    0,    0,
  -12,  270,  335,    0,  -42,    0,  -29,  -29,    0,    0,
    0,   -2,    0,  -42,  288,    0,    0,  143,  143,    0,
    0,  -44,    0,    0,    0,  -12,  -12, -264, -221,    0,
    0,    0,    0,    0,    0,    0, -145,    0,    0,    0,
    0,    0,  288,  288,  288,  288,  288,  288,  288,  288,
    0,    0,    0,  288,  288,  288,  -22,   11,   13,    0,
    0,    0,    0,    0,    0, -219,  459,    0,    0,    0,
  143,  143,    0,    0, -225, -199,    0,   49, -290,   13,
  -31,    0, -155, -148, -142, -140,    0,  -18,  -18,  -25,
  137,  -37,  -37,    0,    0,  459,  459,  453,    0,    0,
    0,    0,   13,    0,    0,    0,  -12,  -12,   13,    0,
    0,    0,    0,    0, -161,    0,    0,   36,    0,
};
const short yyrindex[] = {                                      0,
    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  132,    0,    0,
    0,    0,    0,    0,  108,    0,  401,  401,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  401,  401,    0,
    0,    6,    0,    0,    0,    0,    0,  193,  231,    0,
    0,    0,    0,    0,    0,    0,   60,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  419,  427,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
  401,  401,    0,    0,    0,    0,    0, -218,    0, -215,
    0,    0,    0,    0,    0,    0,    0,   37,   51,   96,
   66,   12,   26,    0,    0,   15,   40,    0,    0,    0,
    0,    0,  153,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
  131,  -17,  -56,    0,   53,    0,    0,    0,    0,    0,
   67,    0,  561,   -7,    0,  104,  555,    0,    0,   29,
   30,  542,  129,    0,    0,
};
#define YYTABLESIZE 754
const short yytable[] = {                                     107,
   12,    2,  106,   25,   79,   17,   46,   47,   27,   80,
   27,   84,   76,   53,   37,   26,   79,   77,  129,   78,
   25,   80,   40,   79,   77,   85,   78,   27,   80,   88,
   98,  103,  113,  114,   41,   92,   90,   88,   80,   38,
   42,   12,   80,   80,  107,   80,   17,   80,   86,   84,
   91,  130,   84,  131,   84,   37,   84,   95,   94,   93,
   80,   80,   80,   85,  132,   88,   85,  134,   85,   84,
   85,   84,   84,   84,   90,  115,  116,   90,   26,   26,
   38,   25,   25,   85,  135,   85,   85,   85,   91,  136,
   90,   91,   30,   88,   90,   89,   90,   90,   90,   30,
   99,  104,  140,   88,   84,   35,   88,   36,   91,  141,
   91,   91,   91,   60,  142,   62,  143,   63,   85,  146,
  147,   91,  148,   88,   80,   88,   88,   88,  149,   90,
   38,    1,   28,  117,    0,   84,   89,  137,  138,    0,
   35,   35,    0,   91,    0,    0,    0,    0,   36,   85,
    0,   35,   35,   89,   90,   89,   89,   89,   88,    0,
   90,    0,    0,    0,    0,   38,   38,    0,    0,    0,
    0,    0,    0,    0,   91,   25,  102,  102,   79,   77,
    0,   78,   27,   80,    0,    0,    0,   26,   89,   88,
   80,    0,    0,    0,   80,   80,    0,   80,    0,   80,
    0,    0,    0,    0,   35,   35,    0,    0,    0,    0,
    0,    0,   80,   80,   80,    0,    0,  105,    0,   89,
    0,    0,    0,    0,    0,   43,    0,    0,    0,  102,
  102,    0,   43,    0,    3,    4,    0,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
   18,   19,   20,    0,   20,   21,   22,   23,   41,   41,
   41,   41,   41,   42,   41,    0,   24,   41,   73,   74,
   42,   20,    0,    0,   46,   47,   80,    0,   50,   51,
   52,    0,    0,   41,   41,    0,    0,    0,   80,   80,
   80,    0,    0,    0,   80,   80,    0,   12,   12,   84,
   84,   84,   17,   17,    0,   84,   84,    0,   84,   84,
    0,   37,   37,   85,   85,   85,    0,    0,    0,   85,
   85,    0,   85,   85,   90,   90,   90,   27,    0,    0,
   90,   90,   26,   90,   90,    0,   38,   38,   91,   91,
   91,    0,    0,   30,   91,   91,    0,   91,   91,    0,
   30,   30,   30,   88,   88,   88,    0,    0,    0,    0,
    0,    0,   88,   88,   40,   40,   40,   40,   40,    0,
   40,    0,   76,   40,    0,    0,   79,   77,    0,   78,
    0,   80,    0,   89,   89,   89,    0,    0,    0,   40,
   40,    0,   89,   89,   83,   82,   81,    0,    0,    0,
    0,    0,    0,    0,   36,   36,    3,    4,    0,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,    0,    0,   20,   21,   22,   23,
   73,   74,    0,   50,   51,   52,    0,    0,   24,    0,
   80,   80,   80,    0,    0,    0,   80,   80,    0,   25,
   25,   43,    0,   43,    0,   43,   81,    0,   75,    0,
   81,   81,    0,   81,   80,   81,    0,    0,   80,   80,
    0,   80,    0,   80,    0,    0,   43,    0,   81,   81,
   81,    0,    0,   43,   43,   43,   80,   80,   80,   42,
   76,   42,    0,   42,   79,   77,   76,   78,    0,   80,
   79,   77,    0,   78,    0,   80,    0,    0,    0,    0,
  145,    0,    0,    0,   42,    0,    0,    0,    0,    0,
    0,   42,   42,   42,    0,    0,   58,   59,   60,   61,
   62,    0,   63,    0,    0,   64,    0,    0,    0,    0,
    0,    0,   81,   37,    0,  144,    0,    0,    0,    0,
   80,   65,   66,    0,    0,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,    0,
    0,   20,   56,    0,   23,    0,   75,    0,   37,   37,
    0,    0,   75,   24,    0,   55,   43,    0,    0,  101,
  101,   89,    0,    0,    0,    0,    0,  111,   56,   89,
    0,    0,  100,  100,    0,   97,    0,    0,    0,    0,
  110,   55,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,   72,    0,    0,    0,   73,   74,
    0,    0,    0,  118,  119,  120,  121,  122,  123,  124,
  125,    0,   37,  101,  126,  127,  128,    0,    0,    0,
    0,    0,  111,    0,    0,  133,  100,   41,   41,   41,
   41,   41,    0,   41,    0,  139,   41,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   56,   56,
    0,    0,   41,   41,    0,    0,    0,    0,    0,    0,
    0,   55,   55,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   81,   81,   81,    0,
    0,    0,   81,   81,   80,   80,   80,    0,    0,    0,
   80,   80,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   73,   74,    0,    0,
    0,    0,   73,   74,
};
const short yycheck[] = {                                      56,
    0,    0,   47,   33,   42,    0,  297,  298,   40,   47,
   40,    0,   38,   31,    0,   45,   42,   43,   41,   45,
   33,   47,  284,   42,   43,    0,   45,   40,   47,   37,
   48,   49,  297,  298,  284,   38,    0,   45,   38,    0,
  284,   41,   42,   43,  101,   45,   41,   47,   91,   38,
    0,   41,   41,   41,   43,   41,   45,   60,   61,   62,
   60,   61,   62,   38,  284,    0,   41,  293,   43,   58,
   45,   60,   61,   62,   38,  297,  298,   41,  297,  298,
   41,  297,  298,   58,  284,   60,   61,   62,   38,   41,
   38,   41,   33,  101,   58,    0,   60,   61,   62,   40,
   48,   49,  258,   38,   93,    2,   41,    0,   58,  258,
   60,   61,   62,  259,  257,  261,  257,  263,   93,  137,
  138,  124,  284,   58,  124,   60,   61,   62,   93,   93,
    2,    0,    2,   67,   -1,  124,   41,  109,  109,   -1,
   37,   38,   -1,   93,   -1,   -1,   -1,   -1,   41,  124,
   -1,   48,   49,   58,  102,   60,   61,   62,   93,   -1,
  124,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   33,   48,   49,   42,   43,
   -1,   45,   40,   47,   -1,   -1,   -1,   45,   93,  124,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,  101,  102,   -1,   -1,   -1,   -1,
   -1,   -1,   60,   61,   62,   -1,   -1,  262,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,  101,
  102,   -1,   40,   -1,  264,  265,   -1,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  284,   -1,  284,  285,  286,  287,  257,  258,
  259,  260,  261,   33,  263,   -1,  296,  266,  294,  295,
   40,  284,   -1,   -1,  297,  298,  124,   -1,  291,  292,
  293,   -1,   -1,  282,  283,   -1,   -1,   -1,  288,  289,
  290,   -1,   -1,   -1,  294,  295,   -1,  297,  298,  288,
  289,  290,  297,  298,   -1,  294,  295,   -1,  297,  298,
   -1,  297,  298,  288,  289,  290,   -1,   -1,   -1,  294,
  295,   -1,  297,  298,  288,  289,  290,   40,   -1,   -1,
  294,  295,   45,  297,  298,   -1,  297,  298,  288,  289,
  290,   -1,   -1,  284,  294,  295,   -1,  297,  298,   -1,
  291,  292,  293,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,   -1,  297,  298,  257,  258,  259,  260,  261,   -1,
  263,   -1,   38,  266,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,  288,  289,  290,   -1,   -1,   -1,  282,
  283,   -1,  297,  298,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  297,  298,  264,  265,   -1,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,   -1,   -1,  284,  285,  286,  287,
  294,  295,   -1,  291,  292,  293,   -1,   -1,  296,   -1,
  288,  289,  290,   -1,   -1,   -1,  294,  295,   -1,  297,
  298,  259,   -1,  261,   -1,  263,   38,   -1,  124,   -1,
   42,   43,   -1,   45,   38,   47,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  284,   -1,   60,   61,
   62,   -1,   -1,  291,  292,  293,   60,   61,   62,  259,
   38,  261,   -1,  263,   42,   43,   38,   45,   -1,   47,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,
   -1,  291,  292,  293,   -1,   -1,  257,  258,  259,  260,
  261,   -1,  263,   -1,   -1,  266,   -1,   -1,   -1,   -1,
   -1,   -1,  124,    2,   -1,   93,   -1,   -1,   -1,   -1,
  124,  282,  283,   -1,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,   -1,
   -1,  284,   31,   -1,  287,   -1,  124,   -1,   37,   38,
   -1,   -1,  124,  296,   -1,   31,   26,   -1,   -1,   48,
   49,   37,   -1,   -1,   -1,   -1,   -1,   56,   57,   45,
   -1,   -1,   48,   49,   -1,   45,   -1,   -1,   -1,   -1,
   56,   57,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,  290,   -1,   -1,   -1,  294,  295,
   -1,   -1,   -1,   73,   74,   75,   76,   77,   78,   79,
   80,   -1,  101,  102,   84,   85,   86,   -1,   -1,   -1,
   -1,   -1,  111,   -1,   -1,  101,  102,  257,  258,  259,
  260,  261,   -1,  263,   -1,  111,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  137,  138,
   -1,   -1,  282,  283,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  137,  138,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,  290,   -1,
   -1,   -1,  294,  295,  288,  289,  290,   -1,   -1,   -1,
  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,
   -1,   -1,  294,  295,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 299
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,"'&'",0,"'('","')'","'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,0,0,
0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'|'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"DST","SRC","HOST","GATEWAY","NET","MASK","PORT",
"LESS","GREATER","PROTO","BYTE","ARP","RARP","IP","TCP","UDP","ICMP","IGMP",
"IGRP","ATALK","DECNET","LAT","SCA","MOPRC","MOPDL","TK_BROADCAST",
"TK_MULTICAST","NUM","INBOUND","OUTBOUND","LINK","GEQ","LEQ","NEQ","ID","EID",
"HID","LSH","RSH","LEN","OR","AND","UMINUS",
};
const char * const yyrule[] = {
"$accept : prog",
"prog : null expr",
"prog : null",
"null :",
"expr : term",
"expr : expr and term",
"expr : expr and id",
"expr : expr or term",
"expr : expr or id",
"and : AND",
"or : OR",
"id : nid",
"id : pnum",
"id : paren pid ')'",
"nid : ID",
"nid : HID '/' NUM",
"nid : HID MASK HID",
"nid : HID",
"nid : EID",
"nid : not id",
"not : '!'",
"paren : '('",
"pid : nid",
"pid : qid and id",
"pid : qid or id",
"qid : pnum",
"qid : pid",
"term : rterm",
"term : not term",
"head : pqual dqual aqual",
"head : pqual dqual",
"head : pqual aqual",
"head : pqual PROTO",
"head : pqual ndaqual",
"rterm : head id",
"rterm : paren expr ')'",
"rterm : pname",
"rterm : arth relop arth",
"rterm : arth irelop arth",
"rterm : other",
"pqual : pname",
"pqual :",
"dqual : SRC",
"dqual : DST",
"dqual : SRC OR DST",
"dqual : DST OR SRC",
"dqual : SRC AND DST",
"dqual : DST AND SRC",
"aqual : HOST",
"aqual : NET",
"aqual : PORT",
"ndaqual : GATEWAY",
"pname : LINK",
"pname : IP",
"pname : ARP",
"pname : RARP",
"pname : TCP",
"pname : UDP",
"pname : ICMP",
"pname : IGMP",
"pname : IGRP",
"pname : ATALK",
"pname : DECNET",
"pname : LAT",
"pname : SCA",
"pname : MOPDL",
"pname : MOPRC",
"other : pqual TK_BROADCAST",
"other : pqual TK_MULTICAST",
"other : LESS NUM",
"other : GREATER NUM",
"other : BYTE NUM byteop NUM",
"other : INBOUND",
"other : OUTBOUND",
"relop : '>'",
"relop : GEQ",
"relop : '='",
"irelop : LEQ",
"irelop : '<'",
"irelop : NEQ",
"arth : pnum",
"arth : narth",
"narth : pname '[' arth ']'",
"narth : pname '[' arth ':' NUM ']'",
"narth : arth '+' arth",
"narth : arth '-' arth",
"narth : arth '*' arth",
"narth : arth '/' arth",
"narth : arth '&' arth",
"narth : arth '|' arth",
"narth : arth LSH arth",
"narth : arth RSH arth",
"narth : '-' arth",
"narth : paren narth ')'",
"narth : LEN",
"byteop : '&'",
"byteop : '|'",
"byteop : '<'",
"byteop : '>'",
"byteop : '='",
"pnum : NUM",
"pnum : paren pnum ')'",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 131 "grammar.y"
{
	finish_parse(yyvsp[0].blk.b);
}
break;
case 3:
#line 136 "grammar.y"
{ yyval.blk.q = qerr; }
break;
case 5:
#line 139 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 6:
#line 140 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 7:
#line 141 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 8:
#line 142 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 9:
#line 144 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; }
break;
case 10:
#line 146 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; }
break;
case 12:
#line 149 "grammar.y"
{ yyval.blk.b = gen_ncode(NULL, (bpf_u_int32)yyvsp[0].i,
						   yyval.blk.q = yyvsp[-1].blk.q); }
break;
case 13:
#line 151 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; }
break;
case 14:
#line 153 "grammar.y"
{ yyval.blk.b = gen_scode(yyvsp[0].s, yyval.blk.q = yyvsp[-1].blk.q); }
break;
case 15:
#line 154 "grammar.y"
{ yyval.blk.b = gen_mcode(yyvsp[-2].s, NULL, yyvsp[0].i,
				    yyval.blk.q = yyvsp[-3].blk.q); }
break;
case 16:
#line 156 "grammar.y"
{ yyval.blk.b = gen_mcode(yyvsp[-2].s, yyvsp[0].s, 0,
				    yyval.blk.q = yyvsp[-3].blk.q); }
break;
case 17:
#line 158 "grammar.y"
{
				  /* Decide how to parse HID based on proto */
				  yyval.blk.q = yyvsp[-1].blk.q;
				  switch (yyval.blk.q.proto) {
				  case Q_DECNET:
					yyval.blk.b = gen_ncode(yyvsp[0].s, 0, yyval.blk.q);
					break;
				  default:
					yyval.blk.b = gen_ncode(yyvsp[0].s, 0, yyval.blk.q);
					break;
				  }
				}
break;
case 18:
#line 170 "grammar.y"
{ yyval.blk.b = gen_ecode(yyvsp[0].e, yyval.blk.q = yyvsp[-1].blk.q); }
break;
case 19:
#line 171 "grammar.y"
{ gen_not(yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 20:
#line 173 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; }
break;
case 21:
#line 175 "grammar.y"
{ yyval.blk = yyvsp[-1].blk; }
break;
case 23:
#line 178 "grammar.y"
{ gen_and(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 24:
#line 179 "grammar.y"
{ gen_or(yyvsp[-2].blk.b, yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 25:
#line 181 "grammar.y"
{ yyval.blk.b = gen_ncode(NULL, (bpf_u_int32)yyvsp[0].i,
						   yyval.blk.q = yyvsp[-1].blk.q); }
break;
case 28:
#line 186 "grammar.y"
{ gen_not(yyvsp[0].blk.b); yyval.blk = yyvsp[0].blk; }
break;
case 29:
#line 188 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-2].i, yyvsp[-1].i, yyvsp[0].i); }
break;
case 30:
#line 189 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, yyvsp[0].i, Q_DEFAULT); }
break;
case 31:
#line 190 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, yyvsp[0].i); }
break;
case 32:
#line 191 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, Q_PROTO); }
break;
case 33:
#line 192 "grammar.y"
{ QSET(yyval.blk.q, yyvsp[-1].i, Q_DEFAULT, yyvsp[0].i); }
break;
case 34:
#line 194 "grammar.y"
{ yyval.blk = yyvsp[0].blk; }
break;
case 35:
#line 195 "grammar.y"
{ yyval.blk.b = yyvsp[-1].blk.b; yyval.blk.q = yyvsp[-2].blk.q; }
break;
case 36:
#line 196 "grammar.y"
{ yyval.blk.b = gen_proto_abbrev(yyvsp[0].i); yyval.blk.q = qerr; }
break;
case 37:
#line 197 "grammar.y"
{ yyval.blk.b = gen_relation(yyvsp[-1].i, yyvsp[-2].a, yyvsp[0].a, 0);
				  yyval.blk.q = qerr; }
break;
case 38:
#line 199 "grammar.y"
{ yyval.blk.b = gen_relation(yyvsp[-1].i, yyvsp[-2].a, yyvsp[0].a, 1);
				  yyval.blk.q = qerr; }
break;
case 39:
#line 201 "grammar.y"
{ yyval.blk.b = yyvsp[0].rblk; yyval.blk.q = qerr; }
break;
case 41:
#line 205 "grammar.y"
{ yyval.i = Q_DEFAULT; }
break;
case 42:
#line 208 "grammar.y"
{ yyval.i = Q_SRC; }
break;
case 43:
#line 209 "grammar.y"
{ yyval.i = Q_DST; }
break;
case 44:
#line 210 "grammar.y"
{ yyval.i = Q_OR; }
break;
case 45:
#line 211 "grammar.y"
{ yyval.i = Q_OR; }
break;
case 46:
#line 212 "grammar.y"
{ yyval.i = Q_AND; }
break;
case 47:
#line 213 "grammar.y"
{ yyval.i = Q_AND; }
break;
case 48:
#line 216 "grammar.y"
{ yyval.i = Q_HOST; }
break;
case 49:
#line 217 "grammar.y"
{ yyval.i = Q_NET; }
break;
case 50:
#line 218 "grammar.y"
{ yyval.i = Q_PORT; }
break;
case 51:
#line 221 "grammar.y"
{ yyval.i = Q_GATEWAY; }
break;
case 52:
#line 223 "grammar.y"
{ yyval.i = Q_LINK; }
break;
case 53:
#line 224 "grammar.y"
{ yyval.i = Q_IP; }
break;
case 54:
#line 225 "grammar.y"
{ yyval.i = Q_ARP; }
break;
case 55:
#line 226 "grammar.y"
{ yyval.i = Q_RARP; }
break;
case 56:
#line 227 "grammar.y"
{ yyval.i = Q_TCP; }
break;
case 57:
#line 228 "grammar.y"
{ yyval.i = Q_UDP; }
break;
case 58:
#line 229 "grammar.y"
{ yyval.i = Q_ICMP; }
break;
case 59:
#line 230 "grammar.y"
{ yyval.i = Q_IGMP; }
break;
case 60:
#line 231 "grammar.y"
{ yyval.i = Q_IGRP; }
break;
case 61:
#line 232 "grammar.y"
{ yyval.i = Q_ATALK; }
break;
case 62:
#line 233 "grammar.y"
{ yyval.i = Q_DECNET; }
break;
case 63:
#line 234 "grammar.y"
{ yyval.i = Q_LAT; }
break;
case 64:
#line 235 "grammar.y"
{ yyval.i = Q_SCA; }
break;
case 65:
#line 236 "grammar.y"
{ yyval.i = Q_MOPDL; }
break;
case 66:
#line 237 "grammar.y"
{ yyval.i = Q_MOPRC; }
break;
case 67:
#line 239 "grammar.y"
{ yyval.rblk = gen_broadcast(yyvsp[-1].i); }
break;
case 68:
#line 240 "grammar.y"
{ yyval.rblk = gen_multicast(yyvsp[-1].i); }
break;
case 69:
#line 241 "grammar.y"
{ yyval.rblk = gen_less(yyvsp[0].i); }
break;
case 70:
#line 242 "grammar.y"
{ yyval.rblk = gen_greater(yyvsp[0].i); }
break;
case 71:
#line 243 "grammar.y"
{ yyval.rblk = gen_byteop(yyvsp[-1].i, yyvsp[-2].i, yyvsp[0].i); }
break;
case 72:
#line 244 "grammar.y"
{ yyval.rblk = gen_inbound(0); }
break;
case 73:
#line 245 "grammar.y"
{ yyval.rblk = gen_inbound(1); }
break;
case 74:
#line 247 "grammar.y"
{ yyval.i = BPF_JGT; }
break;
case 75:
#line 248 "grammar.y"
{ yyval.i = BPF_JGE; }
break;
case 76:
#line 249 "grammar.y"
{ yyval.i = BPF_JEQ; }
break;
case 77:
#line 251 "grammar.y"
{ yyval.i = BPF_JGT; }
break;
case 78:
#line 252 "grammar.y"
{ yyval.i = BPF_JGE; }
break;
case 79:
#line 253 "grammar.y"
{ yyval.i = BPF_JEQ; }
break;
case 80:
#line 255 "grammar.y"
{ yyval.a = gen_loadi(yyvsp[0].i); }
break;
case 82:
#line 258 "grammar.y"
{ yyval.a = gen_load(yyvsp[-3].i, yyvsp[-1].a, 1); }
break;
case 83:
#line 259 "grammar.y"
{ yyval.a = gen_load(yyvsp[-5].i, yyvsp[-3].a, yyvsp[-1].i); }
break;
case 84:
#line 260 "grammar.y"
{ yyval.a = gen_arth(BPF_ADD, yyvsp[-2].a, yyvsp[0].a); }
break;
case 85:
#line 261 "grammar.y"
{ yyval.a = gen_arth(BPF_SUB, yyvsp[-2].a, yyvsp[0].a); }
break;
case 86:
#line 262 "grammar.y"
{ yyval.a = gen_arth(BPF_MUL, yyvsp[-2].a, yyvsp[0].a); }
break;
case 87:
#line 263 "grammar.y"
{ yyval.a = gen_arth(BPF_DIV, yyvsp[-2].a, yyvsp[0].a); }
break;
case 88:
#line 264 "grammar.y"
{ yyval.a = gen_arth(BPF_AND, yyvsp[-2].a, yyvsp[0].a); }
break;
case 89:
#line 265 "grammar.y"
{ yyval.a = gen_arth(BPF_OR, yyvsp[-2].a, yyvsp[0].a); }
break;
case 90:
#line 266 "grammar.y"
{ yyval.a = gen_arth(BPF_LSH, yyvsp[-2].a, yyvsp[0].a); }
break;
case 91:
#line 267 "grammar.y"
{ yyval.a = gen_arth(BPF_RSH, yyvsp[-2].a, yyvsp[0].a); }
break;
case 92:
#line 268 "grammar.y"
{ yyval.a = gen_neg(yyvsp[0].a); }
break;
case 93:
#line 269 "grammar.y"
{ yyval.a = yyvsp[-1].a; }
break;
case 94:
#line 270 "grammar.y"
{ yyval.a = gen_loadlen(); }
break;
case 95:
#line 272 "grammar.y"
{ yyval.i = '&'; }
break;
case 96:
#line 273 "grammar.y"
{ yyval.i = '|'; }
break;
case 97:
#line 274 "grammar.y"
{ yyval.i = '<'; }
break;
case 98:
#line 275 "grammar.y"
{ yyval.i = '>'; }
break;
case 99:
#line 276 "grammar.y"
{ yyval.i = '='; }
break;
case 101:
#line 279 "grammar.y"
{ yyval.i = yyvsp[-1].i; }
break;
#line 1132 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
